function [ z, M_t ] = lfft_gen_lattice_algo23mod( freq )
%LFFT_GEN_LATTICE_ALGO23 Generates a reconstructing rank-1 lattice using CBC construction for random frequency set.

freq_1 = unique(freq(:,1));
P_1 = max(freq_1)-min(freq_1)+1;
for M_t = length(freq_1):P_1
  if length(unique(mod(freq_1,M_t))) == length(freq_1)
    break;
  end
end

z = zeros(1,size(freq,2));
z(1) = 1;

clear freq_1 P_1

for t = 2:size(freq,2)
  M_t_minus_1 = M_t;
  clear M_t
  z(t) = M_t_minus_1;
  freq_t = unique(freq(:,t));
  P_t = max(freq_t)-min(freq_t)+1;
  for S_t = length(freq_t):P_t
    if length(unique(mod(freq_t,S_t))) == length(freq_t)
      break;
    end
  end
  freq_1_t = unique(freq(:,1:t), 'rows');

  optsReduce.Mmin = max(size(freq_1_t,1),z(t));
  optsReduce.display = 'off';
  optsReduce.nthreads = 16;
  optsReduce.increase = 1;
  param_M = min(S_t*M_t_minus_1,8e9);
  M_t = lfft_lattice_size_reduce_mex_23(freq_1_t,param_M,z(1:t),optsReduce);

%   for M_t = min(size(freq_1_t,1),z(t)) : S_t*M_t_minus_1
%     if length(unique(mod(freq_1_t*z(1:t)',M_t))) == size(freq_1_t,1)
%       break;
%     end
%   end
  if length(unique(mod(freq_1_t*z(1:t)',M_t))) ~= size(freq_1_t,1)
    warning('internal error: no reco r1l M_%d=%d',t, M_t);
    return;
  end

  % almost finished because first components t of freq separate
  if size(freq_1_t,1) == size(freq,1)
    break;
  end

end

% first components t of freq separate, fill up with zeros
if t < size(freq,2)
  z(t+1:end) = 0; % = [z, zeros(1,size(freq,2)-t)];
end

z = mod(z,M_t);

if length(unique(mod(freq*z',M_t))) ~= size(freq,1)
  warning('internal error: no reco r1l M=%d', M_t);
end

end

