function [results] = test_mr1l_approx_symhceven_fulllattice1(N_array,d)
%TEST_MR1L_APPROX_SYMHCEVEN_FULLLATTICE1 Computes the number of samples in multiple rank-1 lattices constructed by Algorithm 2.1 for even hyperbolic crosses starting with exponential lattices for the full grid.


filename = sprintf('test_mr1l_approx_symhceven_fulllattice1_d%d.mat',d);

results = {};

for N = N_array
  result = struct();
  result.d = d;
  result.N = N;
  freq = coord_symhc2even(N,d);
  N_I = max(max(freq,[],1)-min(freq,[],1)+1);
  M = N_I^d;
  result.num_freq = size(freq,1);
  fprintf('N=%d, d=%d, s=%d, M=%g, ', N, d, result.num_freq, M);

  if (N_I^(d-1) > 2^62) || (max(sum(abs(freq),2))*N_I^(d-1) > 2^62)
    z = cell(1,d);
    z{1} = int64(1);
    for t=2:d
      z{t} = int64(repmat(N_I,1,t-1));
    end
    fprintf('z large, ');
  else
    z = N_I.^(0:d-1);
  end
  [Ms,hred_array,hrem_array] = deterministic_mr1l_approx_get_lattice_sizes(freq,z,M);
  fprintf('numlat=%d, samples=%d\n', length(Ms), sum(Ms)-length(Ms)+1);
  result.Ms = Ms;
  result.hred_array = hred_array;
  result.hrem_array = hrem_array;
%[[Ms;0], [size(freq,1);hrem_array]];
  results{end+1} = result;
  save(filename', 'N_array', 'd', 'results');
end

