function [results] = test_mr1l_largeMstartS_symhceven(N_array,d)
%TEST_MR1L_LARGEMSTARTS_SYMHCEVEN Computes the number of samples in multiple rank-1 lattices constructed by Theorem 2.8 for even hyperbolic crosses starting with CBC construction.


filename = sprintf('test_mr1l_largeMstartS_symhceven_d%d.mat',d);

results = {};

for N = N_array
  result = struct();
  result.d = d;
  result.N = N;
  freq = coord_symhc2even(N,d);
  [z,M] = get_cbc_recor1l_symhceven(N,d);
  result.num_freq = size(freq,1);
  result.z = z;
  result.M = M;
  [Ms,hred_array,hrem_array] = deterministic_mr1l_get_lattice_sizes_largeMstartS(freq,z,M);
  result.Ms = Ms;
  result.hred_array = hred_array;
  result.hrem_array = hrem_array;
%[[Ms;0], [size(freq,1);hrem_array]];
  results{end+1} = result;
  save(filename', 'N_array', 'd', 'results');
end

